# ne-fe-koa-nginx-jaeger-close

### 简介
[koa2](https://github.com/koajs/koa)的中间件，主要实现http的代理

### 安装&配置说明
$ npm i ne-fe-koa-nginx-jaeger-close --save

### 使用
```
const Koa = require('koa');
const Proxy = require('ne-fe-koa-nginx-jaeger-close');
const app = new Koa();
const Nginx = Proxy.proxy({
  proxies: [
    {
      host: 'http://localhost:3333/',
      context: 'nginx'
    },
  ]
});
app.use(Nginx);
app.listen(3000);
    
```
- `proxyTimeout`
请求的超时时间, 单位毫秒,default 30000

- `rewrite`
路径重写选项,Funtion, 默认 `path.replace(context, '')`, 即去除设置的context路径

- `handleReq`
当数据经过代理前的钩子函数, 参数为一个对象. 包括`proxyReq`,`req`,`res`,`options`
```js
const Nginx = Proxy.proxy({
  proxies: ...,
  handleReq: proxyObj => {
    { proxyReq, req, res, options } = proxyObj;
  }
});
```

- `ctx.tracerRootSpan`
jaeger tracer的rootspan对象，请求结束后会调用finish()方法关闭

- `handleRes`
请求代理后的钩子函数, 包括 `proxyRes`,`req`,`res`

- `error`
请求代理错误的钩子函数,包括 `err`,`req`,`res`

- `proxies`
koa-nginx 的主要参数，数组形式。主要包含如下参数。
  * `target` 需要被代理到的地址
  * `context` 代理前缀，只有满足代理前缀的地址才能被代理。
  * `rewrite` 路径重写.
  * `proxyTimeout` 单独的代理配置的超时。

